"use strict";
import { util } from '../../../util/util.js'
import { fullMap } from '../../../fullMap.js';
import { khcAlert } from '../../../component/alert/khcAlert.js'
let formComponent=null;
let functionMap=new Map();// 使用 Map 来存储多个函数。每个函数都通过 set 方法添加到 Map 中，键是函数名，值是对应的函数。
export function main(jsonConfig) {
    try {
        functionMap.get(jsonConfig.button_method).apply(jsonConfig);
    } catch (error) {
        khcAlert.showSystemError(error.message);
        console.log(error);
    }
}

function fCreate(){
    let jsonConfig=this;
    jsonConfig.formType='create'
    init.call(jsonConfig)
}
functionMap.set('fCreate', fCreate);// 将函数添加到 Map 中

function fEdit(){
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fEdit', fEdit);// 将函数添加到 Map 中

function fVmTableCreate(){
    let jsonConfig=this;
    jsonConfig.formType='create'
    init.call(jsonConfig)
}
functionMap.set('fVmTableCreate', fVmTableCreate);// 将函数添加到 Map 中

function fVmTableEdit(){
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fVmTableEdit', fVmTableEdit);// 将函数添加到 Map 中

function fDetail() {
    let jsonConfig=this;
    jsonConfig.formType='detail'
    init.call(jsonConfig)
}
functionMap.set('fDetail', fDetail);// 将函数添加到 Map 中

let initTypeFunc=null;//类型函数（选择类型时控制是否要填写长度）
function init(){
    let jsonConfig=this;
    let objID = jsonConfig.objID;
    let formType = jsonConfig.formType
    formComponent = fullMap.getObj(objID);
    let eleMap=formComponent.getFormMap();
    if((formType==undefined||formType=='undefined')||formType=='create'){
        formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
    }else if(formType=='edit'){
        initForm(eleMap)//初始化表单的一些限制,或对更改内容添加标注（添加背景颜色代表该字段被更改过）
        if(eleMap.get('type').getValue()!='text'&&eleMap.get('type').getValue()!='longtext'){
            formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
        }else{
            formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:true,isClearValue:true,isShowDiv:false,isCanNull:false})
        }
    }
    if(initTypeFunc!=null){
        document.getElementById(eleMap.get('type').getEleID()).removeEventListener('change', initTypeFunc);
    }
    initTypeFunc= ()=> {
        if(eleMap.get('type').getValue()!='text'&&eleMap.get('type').getValue()!='longtext'){
            formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
        }else{
            formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:true,isClearValue:true,isShowDiv:false,isCanNull:false})
        }
    }


    //验证代码函数
    document.getElementById(eleMap.get('type').getEleID()).addEventListener('change', initTypeFunc);
}
functionMap.set('init', init);// 将函数添加到 Map 中

function initForm(eleMap){
}
let fieldArray=[
    'length'
];



